declare
fun {MapColoring Data NbColors}
   Countries = {Map Data fun {$ C#_} C end} in % list of countries
   proc {$ Coloration}
      Coloration = {FD.record color Countries 1#NbColors}
      {ForAll Data
       proc {$ A#Bs}
	  {ForAll Bs proc {$ B} Coloration.A \=: Coloration.B end}
       end}
      {FD.distribute naive Coloration}
   end 
end 

{Browse {SearchOne {MapColoring Europe 4}}}
